/***************************************************************************
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/

#ifndef __BITPLANE_H
#define __BITPLANE_H

class bitplane {

public:
	bitstream *bs;
	slot *s;
	slot *mask;
	double *data;
	unsigned int *sig;
	unsigned int *newsig;
	unsigned int *select;
	long unsigned int *level;
	unsigned int data_len;
	double data_max;
	double data_max_q;
	unsigned int data_max_q_u;
	double greatest_amp;
	bool is_psy;
	unsigned int idx_filter;
	unsigned int num_nsc;
	unsigned int bits_counter_old;
	unsigned int bits_counter_new;

public:
	bitplane( unsigned int set_data_len, double set_greatest_amp, unsigned int max_numBytes, unsigned int numBlocks, dictionary *dict, unsigned int sampleRate, bool set_is_psy );
	~bitplane( void );
	void plug_data( double *set_data );
	void init( unsigned int target_numBytes );
	unsigned int code( double *set_data, unsigned int target_numBytes );
	unsigned int decode( unsigned int target_numBytes );
	void update_mask( void );
	void select_next( void );
	int sigmap_sign_code( void );
	int refine_code( void );
	int sigmap_sign_decode( void );
	int refine_decode( void );
	int update_level( void );
	void new_coef( unsigned int n, unsigned int sign );
	void refine_coef( unsigned int n, unsigned int ref_bit );
};

#endif
