/***************************************************************************
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/

#ifndef __MDCT_H
#define __MDCT_H

#include "mptk.h"

class mdct {

public:
	unsigned int len;
	unsigned int numFreqs;
	unsigned int windowType;
	double windowOpt;
	double *window;
	fftw_plan p;
	fftw_plan iP;
	fftw_complex *infft;
	fftw_complex *outfft;
	fftw_complex *infftInv;
	fftw_complex *outfftInv;
	double *samples;
	double *mcltRe;
	double *mcltIm;
	double *mcltE;
	double *preModRe;
	double *preModIm;
	double *postModRe;
	double *postModIm;
	double *preModReInv;
	double *preModImInv;
	double *postModReInv;
	double *postModImInv;

public:
	mdct( unsigned int set_len, unsigned int set_windowType, double set_windowOpt );
	~mdct( void );
	void compute_mclt( double *in );
	void compute_inv_mdct( double *in );
};

#endif
