import sys
import os
import threading
import shutil

binroot = sys.argv[1]
wavroot = sys.argv[2]
nThreads = int(sys.argv[3])
snr = int(sys.argv[4])
bitrate = int(sys.argv[5])
zeros = int(sys.argv[6])

wavfiles = []
for root, dirs, files in os.walk(wavroot):
	for filename in files:
		extension = filename[-3:]
		if extension=='wav':
			wavfiles.append(os.path.join(root,filename))

class mptk( threading.Thread ):
	def __init__( self ):
		threading.Thread.__init__( self )
	def run( self ):
		while True:
			if len(wavfiles)==0:
				break
			lock.acquire()
			wavfile = wavfiles[0]
			del wavfiles[0]
			lock.release()
			bookfile = wavfile+'.booktemp'
			codtemp1 = wavfile+'.cod1temp'
			codtemp2 = wavfile+'.cod2temp'
			cod1 = wavfile[:-4]+'.co1'
			cod2 = wavfile[:-4]+'.co2'
			if (not os.path.exists(bookfile) and (not os.path.exists(cod1) or not os.path.exists(cod2)) ):
				cmd = binroot+'/decompose '+wavfile+' '+bookfile+' '+str(snr)+' '+str(zeros)
				os.system(cmd)
			if not os.path.exists(cod1):
				cmd = binroot+'/encoder '+bookfile+' '+codtemp1+' '+str(bitrate)+' 0'
				status = os.system(cmd)
				if status==0:
					shutil.copy( codtemp1, cod1 )
					os.remove(codtemp1)
			if not os.path.exists(cod2):
				cmd = binroot+'/encoder '+bookfile+' '+codtemp2+' '+str(bitrate)+' 1'
				status = os.system(cmd)
				if status==0:
					shutil.copy( codtemp2, cod2 )
					os.remove(codtemp2)
			if os.path.exists(bookfile) and os.path.exists(cod1) and os.path.exists(cod2):
				os.remove(bookfile)
			if os.path.exists(codtemp1) and os.path.exists(cod1):
				os.remove(codtemp1)
			if os.path.exists(codtemp2) and os.path.exists(cod2):
				os.remove(codtemp2)

MyThreads = []
lock = threading.Lock()
for thread in range ( nThreads ):
	s = mptk()
	MyThreads.append(s)
	s.start()
for s in MyThreads:
	s.join()
